# -*- coding: utf-8 -*-
"""
Created on Sat Oct 28 13:47:45 2023

@author: SA-Lenovo
"""

registry = [] 		        # registry will hold references to functions decorated by @register
def register(func): 		# register takes a function as argument
    print(f'running register{func}') 	# Display what function is being decorated, for demonstration
    registry.append(func)   # Include func in registry
    return func 		    # we must return a function; here we return the same received as argument

@register 			        # f1 are decorated by @register
def f1():
    print('running f1()')

@register 			        # f2 are decorated by @register
def f2():
    print('running f2()')

def f3(): 			        # f3 is not decorated
    print('running f3()')

def main(): 			    # main displays the registry, then calls f1(), f2(), and f3()
    print('running main()')
    print('registry ->', registry)
    f1()
    f2()
    f3()

if __name__=='__main__':
    main() 			            # main() is only invoked if registration.py runs as a script
