import turtle
from random import randint

def cover(func, *args): # with star
    func(*args)

def my_decorator(fn):
    def wrapper(*args, **kwargs):
        print(args, kwargs)
        turtle.fillcolor(kwargs['color'])
        turtle.begin_fill()
        fn(*args)
        turtle.end_fill()
    return wrapper

def polygon(sides, length):
    turtle.pendown()
    for x in range(sides):# loop through each side
        # draw the side
        turtle.forward(length)
        # rotate the requisite number of degrees
        turtle.right(360/sides)
    turtle.penup()
        
def generate_random_colour():
    """Generates an R,G,B values randomly in range 0 to 255 """
    r = randint(0, 255)
    g = randint(0, 255)
    b = randint(0, 255)
    return r, g, b

@my_decorator 
def square(length): cover(polygon, 4, length)


turtle.setup(600, 600)
turtle.hideturtle()
turtle.speed(0)
# set tracer values as (1, 0) 
# 1 -> for screen update 
# 0 -> delay 
turtle.tracer(n=0, delay=0)
# set the colormode to 255 
turtle.colormode(255)


maxSideLength = 100
square(maxSideLength, color = generate_random_colour())

for _ in range(1000):
    # choose a random spot
    xpos = randint(-200, 200) - (maxSideLength/2)
    ypos = randint(-200, 200) + (maxSideLength/2)
    turtle.goto(xpos, ypos)

    square(randint(50, 100), color = generate_random_colour())

turtle.done()